> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pdf.co/llms.txt
> Use this file to discover all available pages before exploring further.

# PDF Optimize (DEPRECATED)

> Optimize a PDF file to reduce its size.

## `POST /v1/pdf/optimize`

<Warning>
  **DEPRECATED method - Please use** [**PDF Compress**](/api-reference/pdf-compress)
</Warning>

Not as powerful as [compression](/api-reference/pdf-compress), this function can optimize input PDF files up to 13 times smaller in file size by optimizing images and objects inside.

## Attributes

<Note>
  Attributes are case-sensitive and should be inside JSON for POST request. for example: `{ "url": "https://example.com/file1.pdf" }`
</Note>

| Attribute                 | Type    | Required | Default | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| ------------------------- | ------- | -------- | ------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `url`                     | string  | *Yes*    | -       | URL to the source file [`url attribute`](/api-reference/url-input-and-request-limits#supported-file-sources)                                                                                                                                                                                                                                                                                                                                                                            |
| `callback`                | string  | *No*     | -       | The callback URL (or Webhook) used to receive the POST data. see [Webhooks & Callbacks](/api-reference/webhooks). This is only applicable when `async` is set to `true`.                                                                                                                                                                                                                                                                                                                |
| `httpusername`            | string  | *No*     | -       | HTTP auth user name if required to access source URL.                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| `httppassword`            | string  | *No*     | -       | HTTP auth password if required to access source URL.                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| `name`                    | string  | *No*     | -       | File name for the generated output, the input must be in string format.                                                                                                                                                                                                                                                                                                                                                                                                                 |
| `expiration`              | integer | *No*     | `60`    | Set the expiration time for the output link in minutes. After this specified duration, any generated output file(s) will be automatically deleted from [PDF.co Temporary Files Storage](/api-reference/file-upload/overview). The maximum duration for link expiration varies based on your current subscription plan. To store permanent input files (e.g. re-usable images, pdf templates, documents) consider using [PDF.co Built-In Files Storage](https://app.pdf.co/tools/files). |
| `password`                | string  | *No*     | -       | Password for the PDF file.                                                                                                                                                                                                                                                                                                                                                                                                                                                              |
| `async`                   | boolean | *No*     | `false` | Set `async` to `true` for long processes to run in the background, API will then return a `jobId` which you can use with the [Background Job Check endpoint](/api-reference/job-check). Also see [Webhooks & Callbacks](/api-reference/webhooks)                                                                                                                                                                                                                                        |
| `profiles`                | object  | *No*     | -       | See [Profiles](/api-reference/profiles) for more information.                                                                                                                                                                                                                                                                                                                                                                                                                           |
| `ImageOptimizationFormat` | string  | *No*     | `JPEG`  | Controls image compression format. See [profiles.ImageOptimizationFormat](#profiles-imageoptimizationformat) for more information.                                                                                                                                                                                                                                                                                                                                                      |
| `JPEGQuality`             | integer | *No*     | `25`    | Controls JPEG compression quality. See [profiles.JPEGQuality](#profiles-jpegquality) for more information.                                                                                                                                                                                                                                                                                                                                                                              |
| `ResampleImages`          | boolean | *No*     | `true`  | Tells the compressor to resample images to a new resolution. See [profiles.ResampleImages](#profiles-resampleimages) for more information.                                                                                                                                                                                                                                                                                                                                              |
| `ResamplingResolution`    | integer | *No*     | `120`   | Target resampled images resolution. See [profiles.ResamplingResolution](#profiles-resamplingresolution) for more information.                                                                                                                                                                                                                                                                                                                                                           |
| `GrayscaleImages`         | boolean | *No*     | `false` | Turns all images into grayscale. See [profiles.GrayscaleImages](#profiles-grayscaleimages) for more information.                                                                                                                                                                                                                                                                                                                                                                        |
| `DataEncryptionAlgorithm` | string  | *No*     | -       | Controls the encryption algorithm used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. The available algorithms are: `AES128`, `AES192`, `AES256`.                                                                                                                                                                                                                                                               |
| `DataEncryptionKey`       | string  | *No*     | -       | Controls the encryption key used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                                                                                                                                                                                                                                                                 |
| `DataEncryptionIV`        | string  | *No*     | -       | Controls the encryption IV used for data encryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                                                                                                                                                                                                                                                                  |
| `DataDecryptionAlgorithm` | string  | *No*     | -       | Controls the decryption algorithm used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information. The available algorithms are: `AES128`, `AES192`, `AES256`.                                                                                                                                                                                                                                                               |
| `DataDecryptionKey`       | string  | *No*     | -       | Controls the decryption key used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                                                                                                                                                                                                                                                                 |
| `DataDecryptionIV`        | string  | *No*     | -       | Controls the decryption IV used for data decryption. See [User-Controlled Encryption](/knowledgebase/user-controlled-encryption) for more information.                                                                                                                                                                                                                                                                                                                                  |

### `profiles.ImageOptimizationFormat`

(optional) controls image compression format. Available values:

* `JPEG` (default) JPEG based compression.
* `Flate` (zip-like compression).
* `Fax` 1-bit black and white compression, provides best file size.

### `profiles.JPEGQuality`

(optional) controls JPEG compression quality from `1` (worst quality, smallest size) to `100` (best quality, largest size). Set to `25` by default.

### `profiles.ResampleImages`

(optional) tells the compressor to resample images to a new resolution - `true` by default.

### `profiles.ResamplingResolution`

(optional) target resampled images resolution. `120` (dots per inch) by default.

### `profiles.GrayscaleImages`

(optional) turns all images into grayscale. Not affecting the compression, but useful if you need to make all images inside grayscale - `false` by default.

```json theme={null}
{
 "profiles": "{ 'ImageOptimizationFormat': 'JPEG', 'JPEGQuality': 25, 'ResampleImages': true, 'ResamplingResolution': 120, 'GrayscaleImages': false }"
}
```

## Query parameters

*No query parameters accepted.*

## Responses

| Parameter             | Type           | Description                                                                                                                  |
| --------------------- | -------------- | ---------------------------------------------------------------------------------------------------------------------------- |
| `fileSize`            | integer        | Size of the optimized PDF file in bytes                                                                                      |
| `urls`                | array\[string] | List of URLs to the final PDF file stored in S3.                                                                             |
| `outputLinkValidTill` | string         | Timestamp indicating when the output link will expire                                                                        |
| `pageCount`           | integer        | Number of pages in the PDF document.                                                                                         |
| `error`               | boolean        | Indicates whether an error occurred (`false` means success)                                                                  |
| `status`              | string         | Status code of the request (200, 404, 500, etc.). For more information, see [Response Codes](/api-reference/response-codes). |
| `name`                | string         | Name of the output file                                                                                                      |
| `credits`             | integer        | Number of credits consumed by the request                                                                                    |
| `remainingCredits`    | integer        | Number of credits remaining in the account                                                                                   |
| `duration`            | integer        | Time taken for the operation in milliseconds                                                                                 |

## `Example` Payload

<Note>
  To see the request size limits, please refer to the [Request Size Limits](/api-reference/url-input-and-request-limits#pdf-co-request-size).
</Note>

```json theme={null}
{
  "url": "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-optimize/sample.pdf",
  "name": "output.pdf",
  "profiles": "{ 'ImageOptimizationFormat': 'JPEG', 'JPEGQuality': 25, 'ResampleImages': true, 'ResamplingResolution': 120, 'GrayscaleImages': false }",
  "async": false
}
```

## `Example` Response

<Note>
  To see the main response codes, please refer to the [Response Codes](/api-reference/response-codes) page.
</Note>

```json theme={null}
{
  "url": "https://pdf-temp-files.s3.us-west-2.amazonaws.com/TEPHYOOWTKN47RSMF11CXHXHD7U68ZSS/sample-compressed.pdf?X-Amz-Expires=3600&X-Amz-Security-Token=FwoGZXIvYXdzEEsaDMAT9Cnzd6%2FnDfVKYSKCAU6XCvsgWTRfJHWmoO2iJfJ6YSVShb6ddOXU9Ks5G4Ai20O2idqOaLLslwt6uEnT9EbwpzBMEXuqREkoTTmUOEcXJi9zO5lkLoQ16tXCbfmUF8cvJxVYBXGRHJlzHQ20kJtN6lP237e8rlMtNRIK0f1QsIQswfWy2BFz8IuOndZRu8goquiLmQYyKBBjAmoWcEqs0iMA7MizFAdIbFGydTYXcptaixm%2F%2BfayUZKUByJHURU%3D&X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=ASIA4NRRSZPHNTO33MZG/20220915/us-west-2/s3/aws4_request&X-Amz-Date=20220915T135207Z&X-Amz-SignedHeaders=host&X-Amz-Signature=4f3334f68f1a98d3a9bfe09ec03d3e7d10fb7709ce58b711e36652c59a4d6b4a",
  "fileSize": 798621,
  "pageCount": 5,
  "error": false,
  "status": 200,
  "name": "sample-compressed.pdf",
  "credits": 105,
  "duration": 2886,
  "remainingCredits": 98256037
}
```

<Note>
  **Inconsistent URL Encoding in cURL Output:** When using cURL to make API requests, the output JSON may show URL characters encoded as Unicode escape sequences. For example, the ampersand character (`&`) may appear as `\u0026` in the cURL output. This is normal JSON encoding behavior and does not affect the validity of the URL. The URL will function correctly when used, as JSON parsers automatically decode these escape sequences. If you're parsing the response programmatically, your JSON parser will handle this conversion automatically.
</Note>

## Code Samples

<Tabs>
  <Tab title="CURL">
    ```bash theme={null}
    curl --location --request POST 'https://api.pdf.co/v1/pdf/optimize' \
    --header 'Content-Type: application/json' \
    --header 'x-api-key: *******************' \
    --data-raw '{
    "url": "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-optimize/sample.pdf",
    "name": "output.pdf",
    "profiles": "{ '\''ImageOptimizationFormat'\'': '\''JPEG'\'', '\''JPEGQuality'\'': 25, '\''ResampleImages'\'': true, '\''ResamplingResolution'\'': 120, '\''GrayscaleImages'\'': false }",
    "async": false
    }'
    ```
  </Tab>

  <Tab title="JavaScript/Node.js">
    ```javascript theme={null}
    /*jshint esversion: 6 */

    var https = require("https");
    var path = require("path");
    var fs = require("fs");

    // `request` module is required for file upload.
    // Use "npm install request" command to install.
    var request = require("request");

    // The authentication key (API Key).
    // Get your own by registering at https://app.pdf.co
    const API_KEY = "***********************************";


    // Source PDF file
    const SourceFile = "./sample.pdf";
    // PDF document password. Leave empty for unprotected documents.
    const Password = "";
    // Destination PDF file name
    const DestinationFile = "./result.pdf";


    // 1. RETRIEVE PRESIGNED URL TO UPLOAD FILE.
    getPresignedUrl(API_KEY, SourceFile)
      .then(([uploadUrl, uploadedFileUrl]) => {
          // 2. UPLOAD THE FILE TO CLOUD.
          uploadFile(API_KEY, SourceFile, uploadUrl)
              .then(() => {
                  // 3. OPTIMIZE UPLOADED PDF FILE
                  optimizePdf(API_KEY, uploadedFileUrl, Password, DestinationFile);
              })
              .catch(e => {
                  console.log(e);
              });
      })
      .catch(e => {
          console.log(e);
      });


    function getPresignedUrl(apiKey, localFile) {
      return new Promise(resolve => {
          // Prepare request to `Get Presigned URL` API endpoint
          let queryPath = `/v1/file/upload/get-presigned-url?contenttype=application/octet-stream&name=${path.basename(SourceFile)}`;
          let reqOptions = {
              host: "api.pdf.co",
              path: encodeURI(queryPath),
              headers: { "x-api-key": API_KEY }
          };
          // Send request
          https.get(reqOptions, (response) => {
              response.on("data", (d) => {
                  let data = JSON.parse(d);
                  if (data.error == false) {
                      // Return presigned url we received
                      resolve([data.presignedUrl, data.url]);
                  }
                  else {
                      // Service reported error
                      console.log("getPresignedUrl(): " + data.message);
                  }
              });
          })
              .on("error", (e) => {
                  // Request error
                  console.log("getPresignedUrl(): " + e);
              });
      });
    }

    function uploadFile(apiKey, localFile, uploadUrl) {
      return new Promise(resolve => {
          fs.readFile(SourceFile, (err, data) => {
              request({
                  method: "PUT",
                  url: uploadUrl,
                  body: data,
                  headers: {
                      "Content-Type": "application/octet-stream"
                  }
              }, (err, res, body) => {
                  if (!err) {
                      resolve();
                  }
                  else {
                      console.log("uploadFile() request error: " + e);
                  }
              });
          });
      });
    }

    function optimizePdf(apiKey, uploadedFileUrl, password, destinationFile) {
      // Prepare request to `Optimize PDF` API endpoint
      var queryPath = `/v1/pdf/optimize`;

      // JSON payload for api request
      var jsonPayload = JSON.stringify({
          name: path.basename(destinationFile), password: password, url: uploadedFileUrl, async: true
      });

      var reqOptions = {
          host: "api.pdf.co",
          method: "POST",
          path: queryPath,
          headers: {
              "x-api-key": apiKey,
              "Content-Type": "application/json",
              "Content-Length": Buffer.byteLength(jsonPayload, 'utf8')
          }
      };
      // Send request
      var postRequest = https.request(reqOptions, (response) => {
          response.on("data", (d) => {
              response.setEncoding("utf8");

              // Parse JSON response
              let data = JSON.parse(d);
              console.log(`Job #${data.jobId} has been created!`);

              if (data.error == false) {
                  checkIfJobIsCompleted(data.jobId, data.url, destinationFile);
              }
              else {
                  // Service reported error
                  console.log("readBarcodes(): " + data.message);
              }
          });
      })
          .on("error", (e) => {
              // Request error
              console.log("readBarcodes(): " + e);
          });

      // Write request data
      postRequest.write(jsonPayload);
      postRequest.end();
    }

    function checkIfJobIsCompleted(jobId, resultFileUrl, destinationFile) {
      let queryPath = `/v1/job/check`;

      // JSON payload for api request
      let jsonPayload = JSON.stringify({
          jobid: jobId
      });

      let reqOptions = {
          host: "api.pdf.co",
          path: queryPath,
          method: "POST",
          headers: {
              "x-api-key": API_KEY,
              "Content-Type": "application/json",
              "Content-Length": Buffer.byteLength(jsonPayload, 'utf8')
          }
      };

      // Send request
      var postRequest = https.request(reqOptions, (response) => {
          response.on("data", (d) => {
              response.setEncoding("utf8");

              // Parse JSON response
              let data = JSON.parse(d);
              console.log(`Checking Job #${jobId}, Status: ${data.status}, Time: ${new Date().toLocaleString()}`);

              if (data.status == "working") {
                  // Check again after 3 seconds
                  setTimeout(function () { checkIfJobIsCompleted(jobId, resultFileUrl, destinationFile); }, 3000);
              }
              else if (data.status == "success") {
                  // Download PDF file
                  var file = fs.createWriteStream(destinationFile);
                  https.get(resultFileUrl, (response2) => {
                      response2.pipe(file)
                          .on("close", () => {
                              console.log(`Generated PDF file saved as "${destinationFile}" file.`);
                          });
                  });
              }
              else {
                  console.log(`Operation ended with status: "${data.status}".`);
              }
          })
      });

      // Write request data
      postRequest.write(jsonPayload);
      postRequest.end();
    }
    ```
  </Tab>

  <Tab title="Python">
    ```python theme={null}
    import os
    import requests # pip install requests
    import time
    import datetime

    # The authentication key (API Key).
    # Get your own by registering at https://app.pdf.co
    API_KEY = "******************************************"

    # Base URL for PDF.co Web API requests
    BASE_URL = "https://api.pdf.co/v1"

    # Direct URL of source PDF file.
    # You can also upload your own file into PDF.co and use it as url. Check "Upload File" samples for code snippets: https://github.com/pdfdotco/pdf-co-api-samples/tree/master/File%20Upload/
    SourceFileURL = "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-optimize/sample.pdf"
    # PDF document password. Leave empty for unprotected documents.
    Password = ""
    # Destination PDF file name
    DestinationFile = ".\\result.pdf"
    # (!) Make asynchronous job
    Async = True


    def main(args = None):
      optimizePDF(SourceFileURL, DestinationFile)


    def optimizePDF(uploadedFileUrl, destinationFile):
      """Optimize PDF using PDF.co Web API"""

      # Prepare requests params as JSON
      # See documentation: https://docs.pdf.co
      parameters = {}
      parameters["async"] = Async
      parameters["name"] = os.path.basename(destinationFile)
      parameters["password"] = Password
      parameters["url"] = uploadedFileUrl

      # Prepare URL for 'Optimize PDF' API request
      url = "{}/pdf/optimize".format(BASE_URL)

      # Execute request and get response as JSON
      response = requests.post(url, data=parameters, headers={ "x-api-key": API_KEY })
      if (response.status_code == 200):
          json = response.json()

          if json["error"] == False:
              # Asynchronous job ID
              jobId = json["jobId"]
              #  URL of the result file
              resultFileUrl = json["url"]

              # Check the job status in a loop.
              # If you don't want to pause the main thread you can rework the code
              # to use a separate thread for the status checking and completion.
              while True:
                  status = checkJobStatus(jobId) # Possible statuses: "working", "failed", "aborted", "success".

                  # Display timestamp and status (for demo purposes)
                  print(datetime.datetime.now().strftime("%H:%M.%S") + ": " + status)

                  if status == "success":
                      # Download result file
                      r = requests.get(resultFileUrl, stream=True)
                      if (r.status_code == 200):
                          with open(destinationFile, 'wb') as file:
                              for chunk in r:
                                  file.write(chunk)
                          print(f"Result file saved as \"{destinationFile}\" file.")
                      else:
                          print(f"Request error: {response.status_code} {response.reason}")
                      break
                  elif status == "working":
                      # Pause for a few seconds
                      time.sleep(3)
                  else:
                      print(status)
                      break
          else:
              # Show service reported error
              print(json["message"])
      else:
          print(f"Request error: {response.status_code} {response.reason}")


    def checkJobStatus(jobId):
      """Checks server job status"""

      url = f"{BASE_URL}/job/check?jobid={jobId}"

      response = requests.get(url, headers={ "x-api-key": API_KEY })
      if (response.status_code == 200):
          json = response.json()
          return json["status"]
      else:
          print(f"Request error: {response.status_code} {response.reason}")

      return None

    if __name__ == '__main__':
      main()
    ```
  </Tab>

  <Tab title="C#">
    ```csharp theme={null}
    using System;
    using System.IO;
    using System.Net;
    using Newtonsoft.Json.Linq;
    using System.Threading;
    using System.Collections.Generic;
    using Newtonsoft.Json;


    // Cloud API asynchronous "Optimize PDF" job example.
    // Allows to avoid timeout errors when processing huge or scanned PDF documents.

    namespace PDFcoApiExample
    {
    class Program
    {
      // The authentication key (API Key).
      // Get your own by registering at https://app.pdf.co
      const String API_KEY = "***********************************";

      // Direct URL of source PDF file.
          // You can also upload your own file into PDF.co and use it as url. Check "Upload File" samples for code snippets: https://github.com/pdfdotco/pdf-co-api-samples/tree/master/File%20Upload/
      const string SourceFileUrl = "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-optimize/sample.pdf";
      // PDF document password. Leave empty for unprotected documents.
      const string Password = "";
      // Destination PDF file name
      const string DestinationFile = @".\result.pdf";
      // (!) Make asynchronous job
      const bool Async = true;


      static void Main(string[] args)
      {
        // Create standard .NET web client instance
        WebClient webClient = new WebClient();

        // Set API Key
        webClient.Headers.Add("x-api-key", API_KEY);

        // URL for `Optimize PDF` API call
        string url = "https://api.pdf.co/v1/pdf/optimize";

        // Prepare requests params as JSON
        Dictionary<string, object> parameters = new Dictionary<string, object>();
        parameters.Add("name", Path.GetFileName(DestinationFile));
        parameters.Add("password", Password);
        parameters.Add("url", SourceFileUrl);
        parameters.Add("async", Async);

        // Convert dictionary of params to JSON
        string jsonPayload = JsonConvert.SerializeObject(parameters);

        try
        {
          // Execute POST request with JSON payload
          string response = webClient.UploadString(url, jsonPayload);

          // Parse JSON response
          JObject json = JObject.Parse(response);

          if (json["error"].ToObject<bool>() == false)
          {
            // Asynchronous job ID
            string jobId = json["jobId"].ToString();
            // URL of generated PDF file that will available after the job completion
            string resultFileUrl = json["url"].ToString();

            // Check the job status in a loop.
            // If you don't want to pause the main thread you can rework the code
            // to use a separate thread for the status checking and completion.
            do
            {
              string status = CheckJobStatus(jobId); // Possible statuses: "working", "failed", "aborted", "success".

              // Display timestamp and status (for demo purposes)
              Console.WriteLine(DateTime.Now.ToLongTimeString() + ": " + status);

              if (status == "success")
              {
                // Download PDF file
                webClient.DownloadFile(resultFileUrl, DestinationFile);

                Console.WriteLine("Generated PDF file saved as \"{0}\" file.", DestinationFile);
                break;
              }
              else if (status == "working")
              {
                // Pause for a few seconds
                Thread.Sleep(3000);
              }
              else
              {
                Console.WriteLine(status);
                break;
              }
            }
            while (true);
          }
          else
          {
            Console.WriteLine(json["message"].ToString());
          }
        }
        catch (WebException e)
        {
          Console.WriteLine(e.ToString());
        }

        webClient.Dispose();


        Console.WriteLine();
        Console.WriteLine("Press any key...");
        Console.ReadKey();
      }

      static string CheckJobStatus(string jobId)
      {
        using (WebClient webClient = new WebClient())
        {
          // Set API Key
                  webClient.Headers.Add("x-api-key", API_KEY);

          string url = "https://api.pdf.co/v1/job/check?jobid=" + jobId;

          string response = webClient.DownloadString(url);
          JObject json = JObject.Parse(response);

          return Convert.ToString(json["status"]);
        }
      }
    }
    }
    ```
  </Tab>

  <Tab title="Java">
    ```java theme={null}
    package com.company;

    import com.google.gson.JsonObject;
    import com.google.gson.JsonParser;
    import okhttp3.*;

    import java.io.*;
    import java.net.*;
    import java.nio.file.Path;
    import java.nio.file.Paths;

    public class Main
    {
      // The authentication key (API Key).
      // Get your own by registering at https://app.pdf.co
      final static String API_KEY = "***********************************";

      // Direct URL of source PDF file.
      // You can also upload your own file into PDF.co and use it as url. Check "Upload File" samples for code snippets: https://github.com/pdfdotco/pdf-co-api-samples/tree/master/File%20Upload/
      final static String SourceFileUrl = "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-optimize/sample.pdf";
      // PDF document password. Leave empty for unprotected documents.
      final static String Password = "";
      // Destination PDF file name
      final static Path DestinationFile = Paths.get(".\\result.pdf");


      public static void main(String[] args) throws IOException
      {
          // Create HTTP client instance
          OkHttpClient webClient = new OkHttpClient();

          // Prepare URL for `Optimize PDF` API call
          String query = "https://api.pdf.co/v1/pdf/optimize";

          // Make correctly escaped (encoded) URL
          URL url = null;
          try
          {
              url = new URI(null, query, null).toURL();
          }
          catch (URISyntaxException e)
          {
              e.printStackTrace();
          }

          // Create JSON payload
      String jsonPayload = String.format("{\"name\": \"%s\", \"password\": \"%s\", \"url\": \"%s\"}",
                  DestinationFile.getFileName(),
                  Password,
                  SourceFileUrl);

          // Prepare request body
          RequestBody body = RequestBody.create(MediaType.parse("application/json"), jsonPayload);

          // Prepare request
          Request request = new Request.Builder()
              .url(url)
              .addHeader("x-api-key", API_KEY) // (!) Set API Key
              .addHeader("Content-Type", "application/json")
              .post(body)
              .build();

          // Execute request
          Response response = webClient.newCall(request).execute();


          if (response.code() == 200)
          {
              // Parse JSON response
              JsonObject json = new JsonParser().parse(response.body().string()).getAsJsonObject();

              boolean error = json.get("error").getAsBoolean();
              if (!error)
              {
                  // Get URL of generated PDF file
                  String resultFileUrl = json.get("url").getAsString();

                  // Download PDF file
                  downloadFile(webClient, resultFileUrl, DestinationFile.toFile());

                  System.out.printf("Generated PDF file saved as \"%s\" file.", DestinationFile.toString());
              }
              else
              {
                  // Display service reported error
                  System.out.println(json.get("message").getAsString());
              }
          }
          else
          {
              // Display request error
              System.out.println(response.code() + " " + response.message());
          }
      }

      public static void downloadFile(OkHttpClient webClient, String url, File destinationFile) throws IOException
      {
          // Prepare request
          Request request = new Request.Builder()
                  .url(url)
                  .build();
          // Execute request
          Response response = webClient.newCall(request).execute();

          byte[] fileBytes = response.body().bytes();

          // Save downloaded bytes to file
          OutputStream output = new FileOutputStream(destinationFile);
          output.write(fileBytes);
          output.flush();
          output.close();

          response.close();
      }
    }
    ```
  </Tab>

  <Tab title="PHP">
    ```php theme={null}
    <!DOCTYPE html>
    <html lang="en">
    <head>
      <meta charset="UTF-8">
      <title>Cloud API asynchronous "Optimize PDF" job example (allows to avoid timeout errors).</title>
    </head>
    <body>

    <?php

    // Cloud API asynchronous "Optimize PDF" job example.
    // Allows to avoid timeout errors when processing huge or scanned PDF documents.


    // The authentication key (API Key).
    // Get your own by registering at https://app.pdf.co
    $apiKey = "***********************************";

    // Direct URL of source PDF file. Check another example if you need to upload a local file to the cloud.
    // You can also upload your own file into PDF.co and use it as url. Check "Upload File" samples for code snippets: https://github.com/pdfdotco/pdf-co-api-samples/tree/master/File%20Upload/
    $sourceFileUrl = "https://pdfco-test-files.s3.us-west-2.amazonaws.com/pdf-optimize/sample.pdf";
    // PDF document password. Leave empty for unprotected documents.
    $password = "";

    // Prepare URL for `Optimize PDF` API call
    $url = "https://api.pdf.co/v1/pdf/optimize";

    // Prepare requests params
    $parameters = array();
    $parameters["password"] = $password;
    $parameters["url"] = $sourceFileUrl;
    $parameters["async"] = true; // (!) Make asynchronous job

    // Create Json payload
    $data = json_encode($parameters);

    // Create request
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("x-api-key: " . $apiKey, "Content-type: application/json"));
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $data);

    // Execute request
    $result = curl_exec($curl);

    if (curl_errno($curl) == 0)
    {
      $status_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);

      if ($status_code == 200)
      {
          $json = json_decode($result, true);

          if (!isset($json["error"]) || $json["error"] == false)
          {
              // URL of generated PDF file that will available after the job completion
              $resultFileUrl = $json["url"];
              // Asynchronous job ID
              $jobId = $json["jobId"];

              // Check the job status in a loop
              do
              {
                  $status = CheckJobStatus($jobId, $apiKey); // Possible statuses: "working", "failed", "aborted", "success".

                  // Display timestamp and status (for demo purposes)
                  echo "<p>" . date(DATE_RFC2822) . ": " . $status . "</p>";

                  if ($status == "success")
                  {
                      // Display link to the file with conversion results
                      echo "<div><h2>Conversion Result:</h2><a href='" . $resultFileUrl . "' target='_blank'>" . $resultFileUrl . "</a></div>";
                      break;
                  }
                  else if ($status == "working")
                  {
                      // Pause for a few seconds
                      sleep(3);
                  }
                  else
                  {
                      echo $status . "<br/>";
                      break;
                  }
              }
              while (true);
          }
          else
          {
              // Display service reported error
              echo "<p>Error: " . $json["message"] . "</p>";
          }
      }
      else
      {
          // Display request error
          echo "<p>Status code: " . $status_code . "</p>";
          echo "<p>" . $result . "</p>";
      }
    }
    else
    {
      // Display CURL error
      echo "Error: " . curl_error($curl);
    }

    // Cleanup
    curl_close($curl);


    function CheckJobStatus($jobId, $apiKey)
    {
      $status = null;

    // Create URL
      $url = "https://api.pdf.co/v1/job/check";

      // Prepare requests params
      $parameters = array();
      $parameters["jobid"] = $jobId;

      // Create Json payload
      $data = json_encode($parameters);

      // Create request
      $curl = curl_init();
      curl_setopt($curl, CURLOPT_HTTPHEADER, array("x-api-key: " . $apiKey, "Content-type: application/json"));
      curl_setopt($curl, CURLOPT_URL, $url);
      curl_setopt($curl, CURLOPT_POST, true);
      curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($curl, CURLOPT_POSTFIELDS, $data);

      // Execute request
      $result = curl_exec($curl);

      if (curl_errno($curl) == 0)
      {
          $status_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);

          if ($status_code == 200)
          {
              $json = json_decode($result, true);

              if (!isset($json["error"]) || $json["error"] == false)
              {
                  $status = $json["status"];
              }
              else
              {
                  // Display service reported error
                  echo "<p>Error: " . $json["message"] . "</p>";
              }
          }
          else
          {
              // Display request error
              echo "<p>Status code: " . $status_code . "</p>";
              echo "<p>" . $result . "</p>";
          }
      }
      else
      {
          // Display CURL error
          echo "Error: " . curl_error($curl);
      }

      // Cleanup
      curl_close($curl);

      return $status;
    }

    ?>

    </body>
    </html>
    ```
  </Tab>
</Tabs>
